use std::fs;

pub fn solve() {
    let path = "res/01/input";

    let contents = fs::read_to_string(path).expect("Something went wrong reading the file");

    let mut numbers1 = Vec::<usize>::new();
    let mut numbers2 = Vec::<usize>::new();

    for line in contents.lines() {
        let (n1, n2) = line.split_once("   ").unwrap();
        numbers1.push(n1.parse::<usize>().unwrap());
        numbers2.push(n2.parse::<usize>().unwrap());
    }

    numbers1.sort();
    numbers2.sort();

    let result: usize = numbers1
        .iter()
        .enumerate()
        .map(|(i, n)| n.abs_diff(numbers2[i]))
        .sum();

    println!("Result 1: {}", result);

    let result: usize = numbers1
        .iter()
        .map(|n| numbers2.iter().filter(|n2| n == *n2).count() * n)
        .sum();

    println!("Result 2: {}", result);
}
